;Graphic Library for cfx9850G
;Copyright Martin Poupe (c)2000
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;This libray uses resolution 128x64 pixels in 4 colours
;the [0,0] pixel is in the right bottom corner !
define display db 0DC 03f
include "std8x8.asm" ;font 8x8 standard US ASCII
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;Puts pixel at RW0,RW2 using RB4 color;0=white,1=green,2=blue,3=orange
;overwrites R10..R15,R7C..R7F
plot:   		;plot RW0,RW2,RB4
	dseg 60
	mov,w r7e,0fc00 ;green layer
	and,w r02,3f	;0..63
	add,w r7e,r02	;y coordinate
	mov,w r10,r00	;x
	and,w R10,078	;lower 3 bit of X handled elsewhere
	shl,w r10,1
	shl,w r10,1
	shl,w r10,1	;8*r10->r10
	add,w r7e,r10
	mov,b r12,01	;mask
	mov,w r10,r00
	and,w r10,7	;lower 3 bit of X
maskst:	cmp,b r11,r10
	jz maskdone
	shl,b r12,1
	add,b r11,1
	jmp maskst
maskdone: ;r12 - mask like 00001000
	mov,b r13,r12
	xor,b r13,0ff ;r13=not r12 - like 11110111
	mov,b r15,r4	;color
	call plotkr
        mov,w r7c,400
	sub,w r7e,r7c
	shr,b r15,1
	call plotkr
	Dseg 40
	ret

plotkr:	mov,b r14,[r7e]
	and,b r14,r13 ;clear the pixel
	test,b r15,1 ;is color set ?
	jz plotkr1
	or,b r14,r12 ;set the pixel
plotkr1: mov,b [r7e],r14
	ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
horizontal:
;draws horizontal line from RW0,RW2 to RW0+RB5-1,RW2 using RB4 color
;overwrites R10..R15,R7C..R7F,RW0 modified to RW0+RB5-1, RB5 to 0
        call plot
        add,w R0,1
        sub,b R5,1
        jnz horizontal
        ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
vertical:
;draws vertical line from RW0,RW2 to RW0,RW2+RB5-1 using RB4 color
;overwrites R10..R15,R7C..R7F,RW2 modified to RW2+RB5-1, RB5 to 0
        call plot
        add,w R0,1
        sub,b R5,1
        jnz vertical
        ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;Put 8 pixels at RW0*8,RW2 .. RW0*8+7,RW2 using RB4 color
;0=white,1=green,2=blue,3=orange
;overwrites R10..R15,R7C..R7F
plot8:
	dseg 60
	mov,w r7e,0fc00 ;green layer
	and,w r02,3f	;0..63
	add,w r7e,r02	;y coordinate
	mov,w r10,r00	;x
        shl,w r10,4
	shl,w r10,1
	shl,w r10,1	;64*r10->r10
	add,w r7e,r10
	mov,b r12,0	;clear by default
        test,b r4,1     ;green ?
        jz plot8ng
        mov,b r12,0ffH
plot8ng:mov,b [r7e],r12 ;green layer set
        mov,w r7c,400   ;switch to
	sub,w r7e,r7c   ;blue layer
	mov,b r12,0	;clear by default
        test,b r4,2     ;blue ?
        jz plot8nb
        mov,b r12,0ffH
plot8nb:mov,b [r7e],r12
        Dseg 40
        ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;Puts 1 character RB5 at RW0*8,RW2 .. RW0*8+7,RW2+7 using RB4 color
;low 4 bits: 0=white,1=green,2=blue,3=orange
;high 4 bits: background 0=white,1=green,2=blue,3=orange
;overwrites R08....R1F,R7C..R7F
charxy: mov,w r7c,std8x8
        mov,b r7e,r5
        mov,b r7f,0
        shl,w r7e,4
        shr,w r7e,1
        add,w r7c,r7e ;font adr+8x
        mov,8 r18,[r7c];r18=font
	dseg 60
	mov,w r7e,0fc00 ;green layer
	and,w r02,3f	;0..63
	add,w r7e,r02	;y coordinate
	mov,w r10,r00	;x
        shl,w r10,4
	shl,w r10,1
	shl,w r10,1	;64*r10->r10
	add,w r7e,r10
        mov,8 r00,0
        sub,8 r00,1
        xor,8 r00,r18   ;r00=not r18 (inverse bitmap)
        mov,8 r08,0     ;clear by default
        test,b r04,1    ;green ?
        jz char8ng
        mov,8 r08,r18
char8ng:test,b r04,10  ;green background?
        jz char8BGNG
        or,8 r08,r10
char8BGNG:mov,8 [r7e],r08;green layer set
        mov,w r7c,400   ;switch to
	sub,w r7e,r7c   ;blue layer
        mov,8 r08,0     ;clear by default
        test,b r04,2    ;blue ?
        jz char8nb
        mov,8 r08,r18
char8nb:test,b r04,20  ;blue background?
        jz char8BGNB
        or,8 r08,r10
char8BGNB:mov,8 [r7e],r08;blue layer set
        Dseg 40
        ret
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

